diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/deprecated.h ns-3.39/src/core/model/deprecated.h
--- ns-3.38/src/core/model/deprecated.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/core/model/deprecated.h	2023-07-05 14:23:47.753427000 -0700
@@ -76,6 +76,13 @@
 
 /**
  * \ingroup core
+ * \def NS_DEPRECATED_3_39
+ * Tag for things deprecated in version ns-3.39.
+ */
+#define NS_DEPRECATED_3_39(msg) NS_DEPRECATED(msg)
+
+/**
+ * \ingroup core
  * \def NS_DEPRECATED_3_38
  * Tag for things deprecated in version ns-3.38.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/hash-fnv.h ns-3.39/src/core/model/hash-fnv.h
--- ns-3.38/src/core/model/hash-fnv.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/hash-fnv.h	2023-07-05 14:23:47.753427000 -0700
@@ -98,10 +98,7 @@
     /**
      * Seed value
      */
-    enum Seed
-    {
-        SEED = 0x8BADF00D /**< Ate bad food */
-    };
+    static constexpr auto SEED{0x8BADF00D}; // Ate bad food
 
     /** Cache last hash value, for incremental hashing. */
     /**@{*/
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/hash-murmur3.h ns-3.39/src/core/model/hash-murmur3.h
--- ns-3.38/src/core/model/hash-murmur3.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/hash-murmur3.h	2023-07-05 14:23:47.757427200 -0700
@@ -101,10 +101,7 @@
      * This has to be a constant for all MPI ranks to generate
      * the same hash from the same string.
      */
-    enum Seed
-    {
-        SEED = 0x8BADF00D // Ate bad food
-    };
+    static constexpr auto SEED{0x8BADF00D}; // Ate bad food
 
     /**
      * Cache last hash value, and total bytes hashed (needed to finalize),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/log.cc ns-3.39/src/core/model/log.cc
--- ns-3.38/src/core/model/log.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/log.cc	2023-07-05 14:23:47.757427200 -0700
@@ -168,15 +168,12 @@
     EnvVarCheck();
 
     LogComponent::ComponentList* components = GetComponentList();
-    for (LogComponent::ComponentList::const_iterator i = components->begin();
-         i != components->end();
-         i++)
+
+    if (components->find(name) != components->end())
     {
-        if (i->first == name)
-        {
-            NS_FATAL_ERROR("Log component \"" << name << "\" has already been registered once.");
-        }
+        NS_FATAL_ERROR("Log component \"" << name << "\" has already been registered once.");
     }
+
     components->insert(std::make_pair(name, this));
 }
 
@@ -305,24 +302,18 @@
 LogComponentEnable(const std::string& name, LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    LogComponent::ComponentList::const_iterator i;
-    for (i = components->begin(); i != components->end(); i++)
-    {
-        if (i->first == name)
-        {
-            i->second->Enable(level);
-            return;
-        }
-    }
-    if (i == components->end())
+    auto logComponent = components->find(name);
+
+    if (logComponent == components->end())
     {
-        // nothing matched
         NS_LOG_UNCOND("Logging component \"" << name << "\" not found.");
         LogComponentPrintList();
         NS_FATAL_ERROR("Logging component \""
                        << name << "\" not found."
                        << " See above for a list of available log components");
     }
+
+    logComponent->second->Enable(level);
 }
 
 void
@@ -341,15 +332,11 @@
 LogComponentDisable(const std::string& name, LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    for (LogComponent::ComponentList::const_iterator i = components->begin();
-         i != components->end();
-         i++)
+    auto logComponent = components->find(name);
+
+    if (logComponent != components->end())
     {
-        if (i->first == name)
-        {
-            i->second->Disable(level);
-            break;
-        }
+        logComponent->second->Disable(level);
     }
 }
 
@@ -368,67 +355,73 @@
 void
 LogComponentPrintList()
 {
-    LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    for (LogComponent::ComponentList::const_iterator i = components->begin();
-         i != components->end();
-         i++)
+    // Create sorted map of components by inserting them into a map
+    std::map<std::string, LogComponent*> componentsSorted;
+
+    for (const auto& component : *LogComponent::GetComponentList())
     {
-        std::cout << i->first << "=";
-        if (i->second->IsNoneEnabled())
+        componentsSorted.insert(component);
+    }
+
+    // Iterate through sorted components
+    for (const auto& [name, component] : componentsSorted)
+    {
+        std::cout << name << "=";
+        if (component->IsNoneEnabled())
         {
             std::cout << "0" << std::endl;
             continue;
         }
-        if (i->second->IsEnabled(LOG_LEVEL_ALL))
+        if (component->IsEnabled(LOG_LEVEL_ALL))
         {
             std::cout << "all";
         }
         else
         {
-            if (i->second->IsEnabled(LOG_ERROR))
+            if (component->IsEnabled(LOG_ERROR))
             {
                 std::cout << "error";
             }
-            if (i->second->IsEnabled(LOG_WARN))
+            if (component->IsEnabled(LOG_WARN))
             {
                 std::cout << "|warn";
             }
-            if (i->second->IsEnabled(LOG_DEBUG))
+            if (component->IsEnabled(LOG_DEBUG))
             {
                 std::cout << "|debug";
             }
-            if (i->second->IsEnabled(LOG_INFO))
+            if (component->IsEnabled(LOG_INFO))
             {
                 std::cout << "|info";
             }
-            if (i->second->IsEnabled(LOG_FUNCTION))
+            if (component->IsEnabled(LOG_FUNCTION))
             {
                 std::cout << "|function";
             }
-            if (i->second->IsEnabled(LOG_LOGIC))
+            if (component->IsEnabled(LOG_LOGIC))
             {
                 std::cout << "|logic";
             }
         }
-        if (i->second->IsEnabled(LOG_PREFIX_ALL))
+        if (component->IsEnabled(LOG_PREFIX_ALL))
         {
             std::cout << "|prefix_all";
         }
         else
         {
-            if (i->second->IsEnabled(LOG_PREFIX_FUNC))
+            if (component->IsEnabled(LOG_PREFIX_FUNC))
             {
                 std::cout << "|func";
             }
-            if (i->second->IsEnabled(LOG_PREFIX_TIME))
+            if (component->IsEnabled(LOG_PREFIX_TIME))
             {
                 std::cout << "|time";
             }
-            if (i->second->IsEnabled(LOG_PREFIX_NODE))
+            if (component->IsEnabled(LOG_PREFIX_NODE))
             {
                 std::cout << "|node";
             }
-            if (i->second->IsEnabled(LOG_PREFIX_LEVEL))
+            if (component->IsEnabled(LOG_PREFIX_LEVEL))
             {
                 std::cout << "|level";
             }
@@ -449,17 +442,8 @@
 ComponentExists(std::string componentName)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    LogComponent::ComponentList::const_iterator i;
-    for (i = components->begin(); i != components->end(); i++)
-    {
-        if (i->first == componentName)
-        {
-            return true;
-        }
-    }
-    NS_ASSERT(i == components->end());
-    // nothing matched
-    return false;
+
+    return components->find(componentName) != components->end();
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/log.h ns-3.39/src/core/model/log.h
--- ns-3.38/src/core/model/log.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/log.h	2023-07-05 14:23:47.757427200 -0700
@@ -26,10 +26,10 @@
 #include "time-printer.h"
 
 #include <iostream>
-#include <map>
 #include <stdint.h>
 #include <string>
 #include <type_traits>
+#include <unordered_map>
 #include <vector>
 
 /**
@@ -100,17 +100,17 @@
     LOG_WARN = 0x00000002,       //!< Warning messages.
     LOG_LEVEL_WARN = 0x00000003, //!< LOG_WARN and above.
 
-    LOG_DEBUG = 0x00000004,       //!< Rare ad-hoc debug messages.
-    LOG_LEVEL_DEBUG = 0x00000007, //!< LOG_DEBUG and above.
+    LOG_INFO = 0x00000004,       //!< Something happened to change state.
+    LOG_LEVEL_INFO = 0x00000007, //!< LOG_INFO and above.
 
-    LOG_INFO = 0x00000008,       //!< Informational messages (e.g., banners).
-    LOG_LEVEL_INFO = 0x0000000f, //!< LOG_INFO and above.
+    LOG_FUNCTION = 0x00000008,       //!< Function tracing for non-trivial function calls.
+    LOG_LEVEL_FUNCTION = 0x0000000f, //!< LOG_FUNCTION and above.
 
-    LOG_FUNCTION = 0x00000010,       //!< Function tracing.
-    LOG_LEVEL_FUNCTION = 0x0000001f, //!< LOG_FUNCTION and above.
+    LOG_LOGIC = 0x00000010,       //!< Debugging logs for key branches and decisions in a function.
+    LOG_LEVEL_LOGIC = 0x0000001f, //!< LOG_LOGIC and above.
 
-    LOG_LOGIC = 0x00000020,       //!< Control flow tracing within functions.
-    LOG_LEVEL_LOGIC = 0x0000003f, //!< LOG_LOGIC and above.
+    LOG_DEBUG = 0x00000020,       //!< Full voluminous logging to support debugging.
+    LOG_LEVEL_DEBUG = 0x0000003f, //!< LOG_DEBUG and above.
 
     LOG_ALL = 0x0fffffff,    //!< Print everything.
     LOG_LEVEL_ALL = LOG_ALL, //!< Print everything.
@@ -395,7 +395,7 @@
      * It is exposed here to allow print-introspected-doxygen.cc
      * to generate a list of all LogComponents.
      */
-    typedef std::map<std::string, LogComponent*> ComponentList;
+    using ComponentList = std::unordered_map<std::string, LogComponent*>;
 
     /**
      * Get the list of LogComponents.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/matrix-array.cc ns-3.39/src/core/model/matrix-array.cc
--- ns-3.38/src/core/model/matrix-array.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/matrix-array.cc	2023-07-05 14:23:47.757427200 -0700
@@ -34,7 +34,7 @@
 #endif
 
 template <class T>
-MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, uint16_t numPages)
+MatrixArray<T>::MatrixArray(size_t numRows, size_t numCols, size_t numPages)
     : ValArray<T>(numRows, numCols, numPages)
 {
 }
@@ -58,30 +58,30 @@
 }
 
 template <class T>
-MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values)
+MatrixArray<T>::MatrixArray(size_t numRows, size_t numCols, const std::valarray<T>& values)
     : ValArray<T>(numRows, numCols, values)
 {
 }
 
 template <class T>
-MatrixArray<T>::MatrixArray(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values)
+MatrixArray<T>::MatrixArray(size_t numRows, size_t numCols, std::valarray<T>&& values)
     : ValArray<T>(numRows, numCols, std::move(values))
 {
 }
 
 template <class T>
-MatrixArray<T>::MatrixArray(uint16_t numRows,
-                            uint16_t numCols,
-                            uint16_t numPages,
+MatrixArray<T>::MatrixArray(size_t numRows,
+                            size_t numCols,
+                            size_t numPages,
                             const std::valarray<T>& values)
     : ValArray<T>(numRows, numCols, numPages, values)
 {
 }
 
 template <class T>
-MatrixArray<T>::MatrixArray(uint16_t numRows,
-                            uint16_t numCols,
-                            uint16_t numPages,
+MatrixArray<T>::MatrixArray(size_t numRows,
+                            size_t numCols,
+                            size_t numPages,
                             std::valarray<T>&& values)
     : ValArray<T>(numRows, numCols, numPages, std::move(values))
 {
@@ -96,7 +96,7 @@
 
     MatrixArray<T> res{m_numRows, rhs.m_numCols, m_numPages};
 
-    for (uint16_t page = 0; page < res.m_numPages; ++page)
+    for (size_t page = 0; page < res.m_numPages; ++page)
     {
 #ifdef HAVE_EIGEN3 // Eigen found and enabled Eigen optimizations
 
@@ -108,14 +108,16 @@
 #else // Eigen not found or Eigen optimizations not enabled
 
         size_t matrixOffset = page * m_numRows * m_numCols;
-        for (uint16_t i = 0; i < res.m_numRows; ++i)
+        size_t rhsMatrixOffset = page * rhs.m_numRows * rhs.m_numCols;
+        for (size_t i = 0; i < res.m_numRows; ++i)
         {
-            for (uint16_t j = 0; j < res.m_numCols; ++j)
+            for (size_t j = 0; j < res.m_numCols; ++j)
             {
-                res(i, j, page) =
-                    (m_values[std::slice(matrixOffset + i, m_numCols, m_numRows)] *
-                     rhs.m_values[std::slice(matrixOffset + j * rhs.m_numRows, rhs.m_numRows, 1)])
-                        .sum();
+                res(i, j, page) = (m_values[std::slice(matrixOffset + i, m_numCols, m_numRows)] *
+                                   rhs.m_values[std::slice(rhsMatrixOffset + j * rhs.m_numRows,
+                                                           rhs.m_numRows,
+                                                           1)])
+                                      .sum();
             }
         }
 
@@ -132,7 +134,7 @@
     // m_numPages = this.m_numPages
     MatrixArray<T> res{m_numCols, m_numRows, m_numPages};
 
-    for (uint16_t page = 0; page < m_numPages; ++page)
+    for (size_t page = 0; page < m_numPages; ++page)
     {
 #ifdef HAVE_EIGEN3 // Eigen found and Eigen optimizations enabled
 
@@ -143,7 +145,7 @@
 #else // Eigen not found or Eigen optimizations not enabled
 
         size_t matrixIndex = page * m_numRows * m_numCols;
-        for (uint16_t i = 0; i < m_numRows; ++i)
+        for (size_t i = 0; i < m_numRows; ++i)
         {
             res.m_values[std::slice(matrixIndex + i * res.m_numRows, res.m_numRows, 1)] =
                 m_values[std::slice(matrixIndex + i, m_numCols, m_numRows)];
@@ -174,7 +176,7 @@
     ConstEigenMatrix<T> rMatrixEigen(rMatrix.GetPagePtr(0), rMatrix.m_numRows, rMatrix.m_numCols);
 #endif
 
-    for (uint16_t page = 0; page < m_numPages; ++page)
+    for (size_t page = 0; page < m_numPages; ++page)
     {
 #ifdef HAVE_EIGEN3 // Eigen found and Eigen optimizations enabled
 
@@ -186,14 +188,14 @@
 #else // Eigen not found or Eigen optimizations not enabled
 
         size_t matrixOffset = page * m_numRows * m_numCols;
-        for (uint16_t resRow = 0; resRow < res.m_numRows; ++resRow)
+        for (size_t resRow = 0; resRow < res.m_numRows; ++resRow)
         {
-            for (uint16_t resCol = 0; resCol < res.m_numCols; ++resCol)
+            for (size_t resCol = 0; resCol < res.m_numCols; ++resCol)
             {
                 // create intermediate row result, a multiply of resRow row of lMatrix and each
                 // column of this matrix
                 std::valarray<T> interRes(m_numCols);
-                for (uint16_t thisCol = 0; thisCol < m_numCols; ++thisCol)
+                for (size_t thisCol = 0; thisCol < m_numCols; ++thisCol)
                 {
                     interRes[thisCol] =
                         (lMatrix
@@ -222,7 +224,7 @@
 
     for (size_t index = 0; index < this->GetSize(); ++index)
     {
-        retMatrix[index] = std::conj(m_values[index]);
+        retMatrix.m_values[index] = std::conj(retMatrix.m_values[index]);
     }
     return retMatrix;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/matrix-array.h ns-3.39/src/core/model/matrix-array.h
--- ns-3.38/src/core/model/matrix-array.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/matrix-array.h	2023-07-05 14:23:47.757427200 -0700
@@ -92,7 +92,7 @@
      * \param numCols the number of columns
      * \param numPages the number of pages
      */
-    MatrixArray<T>(uint16_t numRows, uint16_t numCols = 1, uint16_t numPages = 1);
+    MatrixArray<T>(size_t numRows, size_t numCols = 1, size_t numPages = 1);
     /**
      * \brief Constructor creates a single array of values.size () elements and 1 column,
      * and uses std::valarray<T> values to initialize the elements.
@@ -118,7 +118,7 @@
      * \param numCols the number of columns
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(uint16_t numRows, uint16_t numCols, const std::valarray<T>& values);
+    MatrixArray<T>(size_t numRows, size_t numCols, const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single matrix of numRows and numCols, and moves
      * std::valarray<T> values to initialize the elements.
@@ -126,7 +126,7 @@
      * \param numCols the number of columns
      * \param values std::valarray<T> that will be moved to initialize elements of 3D array
      */
-    MatrixArray<T>(uint16_t numRows, uint16_t numCols, std::valarray<T>&& values);
+    MatrixArray<T>(size_t numRows, size_t numCols, std::valarray<T>&& values);
     /**
      * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
      * and uses std::valarray<T> values to initialize all the elements.
@@ -135,10 +135,7 @@
      * \param numPages the number of pages
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(uint16_t numRows,
-                   uint16_t numCols,
-                   uint16_t numPages,
-                   const std::valarray<T>& values);
+    MatrixArray<T>(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
     /**
      * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
      * and moves std::valarray<T> values to initialize all the elements.
@@ -147,10 +144,7 @@
      * \param numPages the number of pages
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(uint16_t numRows,
-                   uint16_t numCols,
-                   uint16_t numPages,
-                   std::valarray<T>&& values);
+    MatrixArray<T>(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
     /** instruct the compiler to generate the implicitly declared destructor*/
     ~MatrixArray<T>() override = default;
     /** instruct the compiler to generate the implicitly declared copy constructor*/
@@ -179,13 +173,13 @@
     /**
      * \brief operator+ definition for MatrixArray<T>.
      * \param rhs The rhs MatrixArray object
-     * \returns The result of operator+ of this MatrixArray and rhs MatrixAray
+     * \returns The result of operator+ of this MatrixArray and rhs MatrixArray
      */
     MatrixArray<T> operator+(const MatrixArray<T>& rhs) const;
     /**
      * \brief binary operator- definition for MatrixArray<T>.
      * \param rhs The rhs MatrixArray object
-     * \returns The result of operator- of this MatrixArray and rhs MatrixAray
+     * \returns The result of operator- of this MatrixArray and rhs MatrixArray
      */
     MatrixArray<T> operator-(const MatrixArray<T>& rhs) const;
     /**
@@ -253,7 +247,7 @@
                                                   EnableBool)>::type>
     MatrixArray<T> HermitianTranspose() const;
 
-  private:
+  protected:
     // To simplify functions in MatrixArray that are using members from the template base class
     using ValArray<T>::m_numRows;
     using ValArray<T>::m_numCols;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/names.cc ns-3.39/src/core/model/names.cc
--- ns-3.38/src/core/model/names.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/names.cc	2023-07-05 14:23:47.757427200 -0700
@@ -307,7 +307,7 @@
          ++i)
     {
         delete i->second;
-        i->second = 0;
+        i->second = nullptr;
     }
 
     m_objectMap.clear();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/nstime.h ns-3.39/src/core/model/nstime.h
--- ns-3.38/src/core/model/nstime.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/nstime.h	2023-07-05 14:23:47.761427200 -0700
@@ -497,7 +497,7 @@
      */
     inline static Time FromInteger(uint64_t value, Unit unit)
     {
-        struct Information* info = PeekInformation(unit);
+        Information* info = PeekInformation(unit);
 
         NS_ASSERT_MSG(info->isValid, "Attempted a conversion from an unavailable unit.");
 
@@ -519,7 +519,7 @@
 
     inline static Time From(const int64x64_t& value, Unit unit)
     {
-        struct Information* info = PeekInformation(unit);
+        Information* info = PeekInformation(unit);
 
         NS_ASSERT_MSG(info->isValid, "Attempted a conversion from an unavailable unit.");
 
@@ -553,7 +553,7 @@
      */
     inline int64_t ToInteger(Unit unit) const
     {
-        struct Information* info = PeekInformation(unit);
+        Information* info = PeekInformation(unit);
 
         NS_ASSERT_MSG(info->isValid, "Attempted a conversion to an unavailable unit.");
 
@@ -576,7 +576,7 @@
 
     inline int64x64_t To(Unit unit) const
     {
-        struct Information* info = PeekInformation(unit);
+        Information* info = PeekInformation(unit);
 
         NS_ASSERT_MSG(info->isValid, "Attempted a conversion to an unavailable unit.");
 
@@ -651,9 +651,9 @@
      *
      *  \return A pointer to the current Resolution
      */
-    static inline struct Resolution* PeekResolution()
+    static inline Resolution* PeekResolution()
     {
-        static struct Time::Resolution& resolution{SetDefaultNsResolution()};
+        static Time::Resolution& resolution{SetDefaultNsResolution()};
         return &resolution;
     }
 
@@ -663,7 +663,7 @@
      *  \param [in] timeUnit The Unit to get Information for
      *  \return The Information for \pname{timeUnit}
      */
-    static inline struct Information* PeekInformation(Unit timeUnit)
+    static inline Information* PeekInformation(Unit timeUnit)
     {
         return &(PeekResolution()->info[timeUnit]);
     }
@@ -673,7 +673,7 @@
      *
      *  \return The Resolution object for the default resolution.
      */
-    static struct Resolution& SetDefaultNsResolution();
+    static Resolution& SetDefaultNsResolution();
     /**
      *  Set the current Resolution.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object-base.cc ns-3.39/src/core/model/object-base.cc
--- ns-3.38/src/core/model/object-base.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object-base.cc	2023-07-05 14:23:47.761427200 -0700
@@ -89,7 +89,7 @@
         NS_LOG_DEBUG("construct tid=" << tid.GetName() << ", params=" << tid.GetAttributeN());
         for (uint32_t i = 0; i < tid.GetAttributeN(); i++)
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(i);
+            TypeId::AttributeInformation info = tid.GetAttribute(i);
             NS_LOG_DEBUG("try to construct \"" << tid.GetName() << "::" << info.name << "\"");
             // is this attribute stored in this AttributeConstructionList instance ?
             Ptr<const AttributeValue> value = attributes.Find(info.checker);
@@ -200,7 +200,7 @@
 ObjectBase::SetAttribute(std::string name, const AttributeValue& value)
 {
     NS_LOG_FUNCTION(this << name << &value);
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     TypeId tid = GetInstanceTypeId();
     if (!tid.LookupAttributeByName(name, &info))
     {
@@ -223,7 +223,7 @@
 ObjectBase::SetAttributeFailSafe(std::string name, const AttributeValue& value)
 {
     NS_LOG_FUNCTION(this << name << &value);
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     TypeId tid = GetInstanceTypeId();
     if (!tid.LookupAttributeByName(name, &info))
     {
@@ -240,7 +240,7 @@
 ObjectBase::GetAttribute(std::string name, AttributeValue& value) const
 {
     NS_LOG_FUNCTION(this << name << &value);
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     TypeId tid = GetInstanceTypeId();
     if (!tid.LookupAttributeByName(name, &info))
     {
@@ -277,7 +277,7 @@
 ObjectBase::GetAttributeFailSafe(std::string name, AttributeValue& value) const
 {
     NS_LOG_FUNCTION(this << name << &value);
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     TypeId tid = GetInstanceTypeId();
     if (!tid.LookupAttributeByName(name, &info))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object.cc ns-3.39/src/core/model/object.cc
--- ns-3.38/src/core/model/object.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object.cc	2023-07-05 14:23:47.761427200 -0700
@@ -96,7 +96,7 @@
     : m_tid(Object::GetTypeId()),
       m_disposed(false),
       m_initialized(false),
-      m_aggregates((struct Aggregates*)std::malloc(sizeof(struct Aggregates))),
+      m_aggregates((Aggregates*)std::malloc(sizeof(Aggregates))),
       m_getObjectCount(0)
 {
     NS_LOG_FUNCTION(this);
@@ -133,7 +133,7 @@
     : m_tid(o.m_tid),
       m_disposed(false),
       m_initialized(false),
-      m_aggregates((struct Aggregates*)std::malloc(sizeof(struct Aggregates))),
+      m_aggregates((Aggregates*)std::malloc(sizeof(Aggregates))),
       m_getObjectCount(0)
 {
     m_aggregates->n = 1;
@@ -242,7 +242,7 @@
 }
 
 void
-Object::UpdateSortedArray(struct Aggregates* aggregates, uint32_t j) const
+Object::UpdateSortedArray(Aggregates* aggregates, uint32_t j) const
 {
     NS_LOG_FUNCTION(this << aggregates << j);
     while (j > 0 &&
@@ -267,8 +267,8 @@
     Object* other = PeekPointer(o);
     // first create the new aggregate buffer.
     uint32_t total = m_aggregates->n + other->m_aggregates->n;
-    struct Aggregates* aggregates =
-        (struct Aggregates*)std::malloc(sizeof(struct Aggregates) + (total - 1) * sizeof(Object*));
+    Aggregates* aggregates =
+        (Aggregates*)std::malloc(sizeof(Aggregates) + (total - 1) * sizeof(Object*));
     aggregates->n = total;
 
     // copy our buffer to the new buffer
@@ -292,8 +292,8 @@
 
     // keep track of the old aggregate buffers for the iteration
     // of NotifyNewAggregates
-    struct Aggregates* a = m_aggregates;
-    struct Aggregates* b = other->m_aggregates;
+    Aggregates* a = m_aggregates;
+    Aggregates* b = other->m_aggregates;
 
     // Then, assign the new aggregation buffer to every object
     uint32_t n = aggregates->n;
@@ -424,7 +424,7 @@
     }
 
     // Now, actually delete all objects
-    struct Aggregates* aggregates = m_aggregates;
+    Aggregates* aggregates = m_aggregates;
     for (uint32_t i = 0; i < n; i++)
     {
         // There is a trick here: each time we call delete below,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object-factory.cc ns-3.39/src/core/model/object-factory.cc
--- ns-3.38/src/core/model/object-factory.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object-factory.cc	2023-07-05 14:23:47.761427200 -0700
@@ -55,11 +55,7 @@
 bool
 ObjectFactory::IsTypeIdSet() const
 {
-    if (m_tid.GetUid() != 0)
-    {
-        return true;
-    }
-    return false;
+    return m_tid.GetUid() != 0;
 }
 
 void
@@ -71,7 +67,7 @@
         return;
     }
 
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     if (!m_tid.LookupAttributeByName(name, &info))
     {
         NS_FATAL_ERROR("Invalid attribute set (" << name << ") on " << m_tid.GetName());
@@ -162,7 +158,7 @@
         else
         {
             std::string name = parameters.substr(cur, equal - cur);
-            struct TypeId::AttributeInformation info;
+            TypeId::AttributeInformation info;
             if (!factory.m_tid.LookupAttributeByName(name, &info))
             {
                 is.setstate(std::ios_base::failbit);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object.h ns-3.39/src/core/model/object.h
--- ns-3.38/src/core/model/object.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object.h	2023-07-05 14:23:47.761427200 -0700
@@ -404,7 +404,7 @@
      * \param [in,out] aggregates The list of aggregated Objects.
      * \param [in] i The most recently used entry in the list.
      */
-    void UpdateSortedArray(struct Aggregates* aggregates, uint32_t i) const;
+    void UpdateSortedArray(Aggregates* aggregates, uint32_t i) const;
     /**
      * Attempt to delete this Object.
      *
@@ -435,7 +435,7 @@
      * array.  The array is shared by all aggregated Objects
      * so the size of the array is indirectly a reference count.
      */
-    struct Aggregates* m_aggregates;
+    Aggregates* m_aggregates;
     /**
      * The number of times the Object was accessed with a
      * call to GetObject().
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object-map.h ns-3.39/src/core/model/object-map.h
--- ns-3.38/src/core/model/object-map.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object-map.h	2023-07-05 14:23:47.761427200 -0700
@@ -102,7 +102,6 @@
                 {
                     *index = (*j).first;
                     return (*j).second;
-                    break;
                 }
             }
             NS_ASSERT(false);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/object-vector.h ns-3.39/src/core/model/object-vector.h
--- ns-3.38/src/core/model/object-vector.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/object-vector.h	2023-07-05 14:23:47.761427200 -0700
@@ -102,7 +102,6 @@
                 {
                     *index = k;
                     return *j;
-                    break;
                 }
             }
             NS_ASSERT(false);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/pointer.h ns-3.39/src/core/model/pointer.h
--- ns-3.38/src/core/model/pointer.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/pointer.h	2023-07-05 14:23:47.761427200 -0700
@@ -140,11 +140,7 @@
             return true;
         }
         T* ptr = dynamic_cast<T*>(PeekPointer(value->GetObject()));
-        if (ptr == nullptr)
-        {
-            return false;
-        }
-        return true;
+        return ptr;
     }
 
     std::string GetValueTypeName() const override
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/random-variable-stream.cc ns-3.39/src/core/model/random-variable-stream.cc
--- ns-3.38/src/core/model/random-variable-stream.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/random-variable-stream.cc	2023-07-05 14:23:47.761427200 -0700
@@ -802,6 +802,7 @@
 }
 
 LogNormalRandomVariable::LogNormalRandomVariable()
+    : m_nextValid(false)
 {
     // m_mu and m_sigma are initialized after constructor by
     // attributes
@@ -851,6 +852,14 @@
 double
 LogNormalRandomVariable::GetValue(double mu, double sigma)
 {
+    if (m_nextValid)
+    { // use previously generated
+        m_nextValid = false;
+        double normal = m_v2 * m_normal;
+
+        return std::exp(sigma * normal + mu);
+    }
+
     double v1;
     double v2;
     double r2;
@@ -878,7 +887,10 @@
         r2 = v1 * v1 + v2 * v2;
     } while (r2 > 1.0 || r2 == 0);
 
-    normal = v1 * std::sqrt(-2.0 * std::log(r2) / r2);
+    m_normal = std::sqrt(-2.0 * std::log(r2) / r2);
+    normal = v1 * m_normal;
+    m_nextValid = true;
+    m_v2 = v2;
 
     x = std::exp(sigma * normal + mu);
 
